summaryrefslogtreecommitdiffstats
path: root/.config/zsh/oh-my-zsh/plugins/emacs
diff options
context:
space:
mode:
authorLibravatarLibravatar Biswakalyan Bhuyan <biswa@surgot.in> 2025-02-13 14:13:49 +0530
committerLibravatarLibravatar Biswakalyan Bhuyan <biswa@surgot.in> 2025-02-13 14:13:49 +0530
commit8a2e1006b3b272126332aa064f3ad95387129544 (patch)
tree944c80ac612a65980d94a54ba11b6c7102037ecf /.config/zsh/oh-my-zsh/plugins/emacs
parentdcbb16d8b08ff5956abef5e6478b59df2e93ad35 (diff)
downloaddotfiles-master.tar.gz
dotfiles-master.tar.bz2
dotfiles-master.zip
new dot filesHEADmaster
Diffstat (limited to '.config/zsh/oh-my-zsh/plugins/emacs')
-rw-r--r--.config/zsh/oh-my-zsh/plugins/emacs/README.md30
-rw-r--r--.config/zsh/oh-my-zsh/plugins/emacs/emacs.plugin.zsh68
-rwxr-xr-x.config/zsh/oh-my-zsh/plugins/emacs/emacsclient.sh38
3 files changed, 136 insertions, 0 deletions
diff --git a/.config/zsh/oh-my-zsh/plugins/emacs/README.md b/.config/zsh/oh-my-zsh/plugins/emacs/README.md
new file mode 100644
index 0000000..c8e33b5
--- /dev/null
+++ b/.config/zsh/oh-my-zsh/plugins/emacs/README.md
@@ -0,0 +1,30 @@
+# Emacs plugin
+
+This plugin utilizes the Emacs daemon capability, allowing the user to quickly open frames, whether they are opened in a terminal via a ssh connection, or X frames opened on the same host. The plugin also provides some aliases for such operations.
+
+- You don't have the cost of starting Emacs all the time anymore
+- Opening a file is as fast as Emacs does not have anything else to do.
+- You can share opened buffered across opened frames.
+- Configuration changes made at runtime are applied to all frames.
+
+**NOTE:** requires Emacs 24 and newer.
+
+To use it, add emacs to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... emacs)
+```
+
+## Aliases
+
+The plugin uses a custom launcher (which we'll call here `$EMACS_LAUNCHER`) that is just a wrapper around [`emacsclient`](https://www.emacswiki.org/emacs/EmacsClient).
+
+| Alias | Command | Description |
+|--------|----------------------------------------------------|----------------------------------------------------------------|
+| emacs | `$EMACS_LAUNCHER --no-wait` | Opens a temporary emacsclient frame |
+| e | `emacs` | Same as emacs alias |
+| te | `$EMACS_LAUNCHER -nw` | Open terminal emacsclient |
+| eeval | `$EMACS_LAUNCHER --eval` | Same as `M-x eval` but from outside Emacs |
+| eframe | `emacsclient --alternate-editor "" --create-frame` | Create new X frame |
+| efile | - | Print the path to the file open in the current buffer |
+| ecd | - | Print the directory of the file open in the the current buffer |
diff --git a/.config/zsh/oh-my-zsh/plugins/emacs/emacs.plugin.zsh b/.config/zsh/oh-my-zsh/plugins/emacs/emacs.plugin.zsh
new file mode 100644
index 0000000..fede5b0
--- /dev/null
+++ b/.config/zsh/oh-my-zsh/plugins/emacs/emacs.plugin.zsh
@@ -0,0 +1,68 @@
+# Emacs 23 daemon capability is a killing feature.
+# One emacs process handles all your frames whether
+# you use a frame opened in a terminal via a ssh connection or X frames
+# opened on the same host.
+
+# Benefits are multiple
+# - You don't have the cost of starting Emacs all the time anymore
+# - Opening a file is as fast as Emacs does not have anything else to do.
+# - You can share opened buffered across opened frames.
+# - Configuration changes made at runtime are applied to all frames.
+
+# Require emacs version to be minimum 24
+autoload -Uz is-at-least
+is-at-least 24 "${${(Az)"$(emacsclient --version 2>/dev/null)"}[2]}" || return 0
+
+# Handle $0 according to the standard:
+# https://zdharma-continuum.github.io/Zsh-100-Commits-Club/Zsh-Plugin-Standard.html
+0="${${ZERO:-${0:#$ZSH_ARGZERO}}:-${(%):-%N}}"
+0="${${(M)0:#/*}:-$PWD/$0}"
+
+# Path to custom emacsclient launcher
+export EMACS_PLUGIN_LAUNCHER="${0:A:h}/emacsclient.sh"
+
+# set EDITOR if not already defined.
+export EDITOR="${EDITOR:-${EMACS_PLUGIN_LAUNCHER}}"
+
+alias emacs="$EMACS_PLUGIN_LAUNCHER --no-wait"
+alias e=emacs
+# open terminal emacsclient
+alias te="$EMACS_PLUGIN_LAUNCHER -nw"
+
+# same than M-x eval but from outside Emacs.
+alias eeval="$EMACS_PLUGIN_LAUNCHER --eval"
+# create a new X frame
+alias eframe='emacsclient --alternate-editor "" --create-frame'
+
+# Emacs ANSI Term tracking
+if [[ -n "$INSIDE_EMACS" ]]; then
+ chpwd_emacs() { print -P "\033AnSiTc %d"; }
+ print -P "\033AnSiTc %d" # Track current working directory
+ print -P "\033AnSiTu %n" # Track username
+
+ # add chpwd hook
+ autoload -Uz add-zsh-hook
+ add-zsh-hook chpwd chpwd_emacs
+fi
+
+# Write to standard output the path to the file
+# opened in the current buffer.
+function efile {
+ local cmd="(buffer-file-name (window-buffer))"
+ local file="$("$EMACS_PLUGIN_LAUNCHER" --eval "$cmd" | tr -d \")"
+
+ if [[ -z "$file" ]]; then
+ echo "Can't deduce current buffer filename." >&2
+ return 1
+ fi
+
+ echo "$file"
+}
+
+# Write to standard output the directory of the file
+# opened in the the current buffer
+function ecd {
+ local file
+ file="$(efile)" || return $?
+ echo "${file:h}"
+}
diff --git a/.config/zsh/oh-my-zsh/plugins/emacs/emacsclient.sh b/.config/zsh/oh-my-zsh/plugins/emacs/emacsclient.sh
new file mode 100755
index 0000000..25efe0d
--- /dev/null
+++ b/.config/zsh/oh-my-zsh/plugins/emacs/emacsclient.sh
@@ -0,0 +1,38 @@
+#!/bin/sh
+
+emacsfun() {
+ local cmd frames
+
+ # Build the Emacs Lisp command to check for suitable frames
+ # See https://www.gnu.org/software/emacs/manual/html_node/elisp/Frames.html#index-framep
+ case "$*" in
+ *-t*|*--tty*|*-nw*) cmd="(memq 't (mapcar 'framep (frame-list)))" ;; # if != nil, there are tty frames
+ *) cmd="(delete 't (mapcar 'framep (frame-list)))" ;; # if != nil, there are graphical terminals (x, w32, ns)
+ esac
+
+ # Check if there are suitable frames
+ frames="$(emacsclient -a '' -n -e "$cmd" 2>/dev/null)"
+
+ # Only create another X frame if there isn't one present
+ if [ -z "$frames" -o "$frames" = nil ]; then
+ emacsclient --alternate-editor "" --create-frame "$@"
+ return $?
+ fi
+
+ emacsclient --alternate-editor "" "$@"
+}
+
+# Adapted from https://github.com/davidshepherd7/emacs-read-stdin/blob/master/emacs-read-stdin.sh
+# If the second argument is - then write stdin to a tempfile and open the
+# tempfile. (first argument will be `--no-wait` passed in by the plugin.zsh)
+if [ $# -ge 2 -a "$2" = "-" ]; then
+ # Create a tempfile to hold stdin
+ tempfile="$(mktemp --tmpdir emacs-stdin-$USERNAME.XXXXXXX 2>/dev/null \
+ || mktemp -t emacs-stdin-$USERNAME)" # support BSD mktemp
+ # Redirect stdin to the tempfile
+ cat - > "$tempfile"
+ # Reset $2 to the tempfile so that "$@" works as expected
+ set -- "$1" "$tempfile" "${@:3}"
+fi
+
+emacsfun "$@"